
Ahoy.WorldMapIcons = {}
Ahoy.WorldmMapIconLimit = 10;

function Ahoy_CreateMapPins()
	for i = 1, Ahoy.WorldmMapIconLimit, 1 do
		local mapIcon = CreateFrame("Frame","Ahoy_MapIcon_".. i,WorldMapFrame.ScrollContainer.Child)
		mapIcon:SetFrameStrata("HIGH")
		mapIcon:SetWidth(20)
		mapIcon:SetHeight(20)
		mapIcon:SetPoint("BOTTOMLEFT",i * 400, 100)
		local mapIcon_Texture = mapIcon:CreateTexture("Ahoy_MapIconTexture_".. i)
		mapIcon_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
		mapIcon_Texture:SetTexCoord(0.54, .665, .43, 0.55) 
		mapIcon_Texture:SetAllPoints(mapIcon)
		mapIcon.texture = mapIcon_Texture;
		Ahoy.WorldMapIcons[i] = mapIcon;
	end
end

function Ahoy_ClearMapPins()
	for i = 1, Ahoy.WorldmMapIconLimit, 1 do
		Ahoy.WorldMapIcons[i]:Hide();
	end
end

function Ahoy_DEBUGShowAllMapPins()
	for i = 1, Ahoy.WorldmMapIconLimit, 1 do
		Ahoy.WorldMapIcons[i]:Show();
	end
end

function Ahoy_UpdateMap( isOpen )
	if Ahoy.DoingIslandExpedition == true then
		if Ahoy_Settings_New.MapIcons == true then
			Ahoy_ClearMapPins();
			local mapID = WorldMapFrame:GetMapID();
			local uiMapDetails = C_Map.GetMapInfo(mapID);
			local selectedMap = uiMapDetails.name;
			if AhoyMapDB[selectedMap] ~= nil then
				local pinNumber = getn(AhoyMapDB[selectedMap]);
				for p = 1, pinNumber, 1 do
					local x = 0.0;
					local y = 0.0;
					local dataArray = AhoyMapDB[selectedMap];
					local dataString = dataArray[p];
					local type, xPercentStr, yPercentStr = strsplit('|',dataString);
					local xPercent = tonumber(xPercentStr);
					local yPercent = tonumber(yPercentStr);
					local mapSizeX = WorldMapFrame.ScrollContainer.Child:GetWidth();
					local mapSizeY = WorldMapFrame.ScrollContainer.Child:GetHeight();
					local x = (xPercent / 100) * mapSizeX;
					local y = (yPercent / 100) * mapSizeY;
					if type == "Rare" then
						Ahoy.WorldMapIcons[p].texture:SetTexCoord(0.54, .665, .43, 0.55) 
					elseif type == "Cave" then
						Ahoy.WorldMapIcons[p].texture:SetTexCoord(0.54-.13, .665-.15, .43, 0.55) 
					end
					local iconSize = mapSizeX/25;
					Ahoy.WorldMapIcons[p]:ClearAllPoints();
					Ahoy.WorldMapIcons[p]:SetPoint("BOTTOMLEFT", x-(iconSize/2) , y-(iconSize/2));
					Ahoy.WorldMapIcons[p]:SetWidth(iconSize)
					Ahoy.WorldMapIcons[p]:SetHeight(iconSize)
					Ahoy.WorldMapIcons[p]:Show();
				end
			end
		else
			Ahoy_ClearMapPins();
		end
	end
end

function Ahoy_WorldMapInitialize()
	Ahoy_CreateMapPins();
	Ahoy_ClearMapPins();
end